.686
.model flat,stdcall
option casemap:none
option proc:private
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib
include stdlib.inc
includelib stdlib.lib
;include comctl32.inc
;includelib comctl32.lib

include .\DzControls.Inc

FBStruc struct
	bMouseOver dd 0
	dwBtnState dd 0
	hFont dd 0
FBStruc ends

FlatBorder PROTO stdcall :DWORD,:DWORD,:DWORD,:DWORD

.data
align 4
szClassNameFB db SZ_FB_CLASSNAME,0
align 4

.code

FlatBorder proc stdcall uses ebx  hdc:DWORD,Brd_Outer:DWORD,Brd_Inner:DWORD,lpRect:dword
LOCAL hPen:DWORD, hPen2:DWORD, hPenOld:DWORD
	mov ebx,lpRect
	invoke InflateRect,addr [ebx],-1,-1 
	invoke CreatePen,PS_SOLID,1,Brd_Outer
	mov hPen, eax
	invoke CreatePen,PS_SOLID,1,Brd_Inner
	mov hPen2, eax
	invoke SelectObject,hdc,hPen
	mov hPenOld, eax
	invoke MoveToEx,hdc,[ebx].RECT.left,[ebx].RECT.top,0
	invoke LineTo,hdc,[ebx].RECT.right,[ebx].RECT.top
	invoke MoveToEx,hdc,[ebx].RECT.left,[ebx].RECT.top,0
	invoke LineTo,hdc,[ebx].RECT.left,[ebx].RECT.bottom
	invoke SelectObject,hdc,hPen2
	invoke MoveToEx,hdc,[ebx].RECT.left,[ebx].RECT.bottom,0
	invoke LineTo,hdc,[ebx].RECT.right,[ebx].RECT.bottom
	invoke MoveToEx,hdc,[ebx].RECT.right,[ebx].RECT.top,0
	mov eax,[ebx].RECT.bottom
	inc eax
	invoke LineTo,hdc,[ebx].RECT.right,eax
	invoke SelectObject,hdc,hPenOld
	invoke DeleteObject,hPen
	invoke DeleteObject,hPen2
	invoke InflateRect,addr [ebx],1,1
	ret
FlatBorder endp

FB_OnPaint proc stdcall hWnd
LOCAL ps:PAINTSTRUCT,hOldFont,rc:RECT
LOCAL capbuff[100h]:byte
	invoke GetClientRect,hWnd,addr rc
	invoke BeginPaint,hWnd,addr ps
	invoke SetBkMode,ps.hdc,TRANSPARENT
	invoke GetSysColor,COLOR_BTNTEXT
	invoke SetTextColor,ps.hdc,eax
	invoke GetWindowLong,hWnd,FBStruc.hFont
	invoke SelectObject,ps.hdc,eax
	mov hOldFont,eax
	invoke GetSysColorBrush,COLOR_BTNFACE
	invoke FillRect,ps.hdc,addr rc,eax
	invoke GetWindowLong,hWnd,FBStruc.dwBtnState
	.if (eax & ODS_SELECTED)
		invoke GetSysColor,COLOR_BTNSHADOW
		push eax
		invoke GetSysColor,COLOR_BTNHILIGHT
		lea edx,rc
		pop ecx
		invoke FlatBorder,ps.hdc,ecx,eax,edx
		invoke OffsetRect,addr rc,1,1
	.else
	invoke GetWindowLong,hWnd,FBStruc.bMouseOver
	.if eax
		invoke GetSysColor,COLOR_BTNSHADOW
		push eax
		invoke GetSysColor,COLOR_BTNHILIGHT
		lea edx,rc
		pop ecx
		invoke FlatBorder,ps.hdc,eax,ecx,edx
	.endif
	.endif	
	invoke GetWindowText,hWnd,addr capbuff,sizeof capbuff
	lea edx,rc
	lea ecx,capbuff
	invoke DrawText,ps.hdc,ecx,eax,edx,DT_CENTER or DT_VCENTER or DT_SINGLELINE or DT_NOCLIP
	invoke GetWindowLong,hWnd,FBStruc.dwBtnState
	.if (eax & ODS_FOCUS)
		invoke InflateRect,addr rc,-4,-4
		invoke DrawFocusRect,ps.hdc,addr rc
	.endif
	invoke SelectObject,ps.hdc,hOldFont
	invoke EndPaint,hWnd,addr ps
	ret
FB_OnPaint endp

FBProc proc stdcall hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL rc:RECT,hParent:dword
	mov eax,uMsg
	.if eax == WM_MOUSEMOVE
		invoke GetParent,hWnd
		mov hParent,eax
		invoke GetActiveWindow
		.if eax == hParent
			invoke GetClientRect,hWnd,addr rc
			mov edx,lParam
			movzx eax,dx
			shr edx,16
			invoke PtInRect,addr rc,eax,edx
			.if eax
				invoke GetCapture
				.if !eax
					invoke SetCapture,hWnd
					invoke SetWindowLong,hWnd,FBStruc.bMouseOver,TRUE
					invoke InvalidateRect,hWnd,0,FALSE
				.endif
			.else
				invoke GetCapture
				.if eax
					invoke ReleaseCapture
					invoke SetWindowLong,hWnd,FBStruc.bMouseOver,FALSE
					invoke GetWindowLong,hWnd,FBStruc.dwBtnState
					and eax,not ODS_SELECTED
					invoke SetWindowLong,hWnd,FBStruc.dwBtnState,eax
					invoke InvalidateRect,hWnd,0,FALSE
				.endif
			.endif
		.endif
	.elseif eax == WM_ERASEBKGND
		invoke InvalidateRect,hWnd,0,FALSE
	.elseif eax == WM_PAINT 
		invoke FB_OnPaint,hWnd
	.elseif eax == WM_LBUTTONDOWN || eax == WM_LBUTTONDBLCLK
		invoke SetFocus,hWnd
		invoke GetWindowLong,hWnd,FBStruc.dwBtnState
		or eax,ODS_SELECTED
		invoke SetWindowLong,hWnd,FBStruc.dwBtnState,eax
		invoke InvalidateRect,hWnd,0,FALSE
	.elseif eax == WM_KEYDOWN
		cmp wParam,VK_SPACE
		je @@BM_CLICK
	.elseif eax == WM_LBUTTONUP
		invoke GetWindowLong,hWnd,FBStruc.dwBtnState
		.if eax & ODS_SELECTED
			and eax,not ODS_SELECTED
			invoke SetWindowLong,hWnd,FBStruc.dwBtnState,eax
			invoke InvalidateRect,hWnd,0,FALSE
			invoke SendMessage,hWnd,BM_CLICK,0,0
		.endif
	.elseif eax == BM_CLICK
	@@BM_CLICK:
		invoke GetWindowLong,hWnd,GWL_ID
		push eax
		invoke GetParent,hWnd
		pop edx
		invoke SendMessage,eax,WM_COMMAND,edx,BN_CLICKED
	.elseif eax == WM_SETFOCUS
		invoke GetWindowLong,hWnd,FBStruc.dwBtnState
		or eax,ODS_FOCUS
		invoke SetWindowLong,hWnd,FBStruc.dwBtnState,eax
		invoke InvalidateRect,hWnd,0,FALSE
	.elseif eax == WM_KILLFOCUS
		invoke GetWindowLong,hWnd,FBStruc.dwBtnState
		and eax,not ODS_FOCUS
		invoke SetWindowLong,hWnd,FBStruc.dwBtnState,eax
		invoke ReleaseCapture
		invoke SetWindowLong,hWnd,FBStruc.bMouseOver,FALSE
		invoke InvalidateRect,hWnd,0,FALSE
	.elseif eax == WM_GETFONT
		invoke GetWindowLong,hWnd,FBStruc.hFont
		ret
	.elseif eax == WM_SETFONT
		invoke SetWindowLong,hWnd,FBStruc.hFont,wParam
		.if lParam
			invoke InvalidateRect,hWnd,0,FALSE
		.endif
	.elseif eax == WM_CREATE
		invoke GetParent,hWnd
		invoke SendMessage,eax,WM_GETFONT,0,0
		invoke SetWindowLong,hWnd,FBStruc.hFont,eax
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
FBProc endp

; initializes all custom controls
InitFlatButton proc stdcall public uses edi hInst
LOCAL wc:WNDCLASSEX

	invoke ZeroMemory,addr wc,sizeof WNDCLASSEX  
	mov wc.cbSize,sizeof WNDCLASSEX  
	mov wc.style,CS_DBLCLKS or CS_BYTEALIGNWINDOW or CS_HREDRAW or CS_VREDRAW  
	mov wc.lpfnWndProc,offset FBProc
	mov wc.cbWndExtra,sizeof FBStruc
	mov eax,hInst
	lea edi,wc
	mov wc.hInstance,eax
	invoke GetSysColorBrush,COLOR_INFOBK
	mov edx,offset szClassNameFB
	mov wc.hbrBackground,eax
	mov wc.lpszClassName,edx
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,edi
	ret
InitFlatButton endp

end
